"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const useAnimatedRef_1 = __importDefault(require("../hooks/useAnimatedRef"));
const common_1 = require("./common");
// typescript's really not liking the mapping between tags/elements/attributes, but type safety for component props is working except for the ref
// TODO fix typesafety for refs
// TODO see if we can get cleaner types in this component
const controlledAnimated = (props, forwardedRef) => {
    const { as: Tag = "div", animations, currentAnimation, onAnimationEnd, ...tagProps } = props;
    const animatedRef = (0, useAnimatedRef_1.default)(currentAnimation, animations, onAnimationEnd);
    const elementRef = (0, react_1.useCallback)((0, common_1.mergeRefs)(forwardedRef, 
    // @ts-ignore
    animatedRef), [forwardedRef]);
    return (
    // @ts-ignore 
    react_1.default.createElement(Tag
    // @ts-ignore 
    , { 
        // @ts-ignore 
        ref: elementRef, ...tagProps }));
};
/**
 * An Animated component that is controlled by the currentAnimation prop
 * The component may use a different HTML tag delegate via the `as` prop
 * May accept a ref to forward to the HTML tag delegate.
 * Note: forwarding a ref returned from {@link hooks.useAnimatedRef} may result in undeterministic behavior
 *
 * @typeParam A the accepted animation names
 * @typeParam T the HTML Tag delegate
 */
const ControlledAnimated = react_1.default.forwardRef(controlledAnimated);
controlledAnimated.displayName = "ControlledAnimated";
exports.default = ControlledAnimated;
