import { RenderResult } from '@testing-library/react';
import React from 'react';
export declare const isolatedRender: (el: React.ReactElement) => RenderResult;
export declare const isolatedCleanup: () => void;
export interface CurrentPointer<T> {
    current: T;
}
/**
 * Helper to run testing-library-react's `act` and work with the result
 * Assumes a mutable "current" pointer will be updated by each act() (e.g. RenderHookResult)
 */
export declare function actAndThen<T>(renderResult: CurrentPointer<T>, actBody: ((current: T) => void) | Array<(current: T) => void>, expectBody: (updated: T) => void): void;
export declare function actAndThenAsync<T>(renderResult: CurrentPointer<T>, actBody: ((current: T) => Promise<void>) | Array<(current: T) => Promise<void>>, expectBody: (updated: T) => Promise<void>): Promise<void>;
export declare function expectEachExtends<T>(actual: T[], expected: Partial<T>[]): void;
export declare function expectMatchingKeyframes(webAnimation: Animation, expected: Keyframe[]): void;
