"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.expectMatchingKeyframes = exports.expectEachExtends = exports.actAndThenAsync = exports.actAndThen = exports.isolatedCleanup = exports.isolatedRender = void 0;
const react_1 = require("@testing-library/react");
const react_2 = __importDefault(require("react"));
const isolatedRender = (el) => {
    const { container } = (0, react_1.render)(react_2.default.createElement('div', { id: expect.getState().currentTestName }));
    return (0, react_1.render)(el, { container });
};
exports.isolatedRender = isolatedRender;
// test.afterEach
const isolatedCleanup = () => {
    const container = document.getElementById(expect.getState().currentTestName);
    if (container) {
        document.removeChild(container);
    }
};
exports.isolatedCleanup = isolatedCleanup;
/**
 * Helper to run testing-library-react's `act` and work with the result
 * Assumes a mutable "current" pointer will be updated by each act() (e.g. RenderHookResult)
 */
function actAndThen(renderResult, actBody, expectBody) {
    if (typeof actBody === 'function') {
        (0, react_1.act)(() => actBody(renderResult.current));
    }
    else {
        for (const frame of actBody) {
            (0, react_1.act)(() => frame(renderResult.current));
        }
    }
    expectBody(renderResult.current);
}
exports.actAndThen = actAndThen;
async function actAndThenAsync(renderResult, actBody, expectBody) {
    if (typeof actBody === 'function') {
        await (0, react_1.act)(async () => await actBody(renderResult.current));
    }
    else {
        for (const frame of actBody) {
            await (0, react_1.act)(async () => await frame(renderResult.current));
        }
    }
    await expectBody(renderResult.current);
}
exports.actAndThenAsync = actAndThenAsync;
function expectEachExtends(actual, expected) {
    expected.forEach((maybeSubset, i) => {
        const maybeSuperset = actual[i];
        expect(maybeSuperset).toMatchObject(maybeSubset);
    });
}
exports.expectEachExtends = expectEachExtends;
function expectMatchingKeyframes(webAnimation, expected) {
    expectEachExtends(webAnimation.effect.getKeyframes(), expected);
}
exports.expectMatchingKeyframes = expectMatchingKeyframes;
